package dev.shadowsoffire.apotheosis.adventure.socket.gem.bonus.special;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.google.common.base.Preconditions;
import com.mojang.datafixers.kinds.App;
import com.mojang.datafixers.kinds.Applicative;
import com.mojang.datafixers.util.Function4;
import com.mojang.serialization.Codec;
import com.mojang.serialization.codecs.RecordCodecBuilder;
import dev.shadowsoffire.apotheosis.Apotheosis;
import dev.shadowsoffire.apotheosis.adventure.affix.Affix;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.GemClass;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.GemItem;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.bonus.GemBonus;
import dev.shadowsoffire.placebo.codec.PlaceboCodecs;
import dev.shadowsoffire.placebo.util.StepFunction;
import java.util.List;
import java.util.Map;
import java.util.UUID;
import java.util.function.BiConsumer;
import net.minecraft.ChatFormatting;
import net.minecraft.core.registries.BuiltInRegistries;
import net.minecraft.network.chat.Component;
import net.minecraft.world.entity.ai.attributes.Attribute;
import net.minecraft.world.entity.ai.attributes.AttributeModifier;
import net.minecraft.world.item.ItemStack;

public class AllStatsBonus extends GemBonus {
  public static Codec<dev.shadowsoffire.apotheosis.adventure.socket.gem.bonus.special.AllStatsBonus> CODEC;
  
  protected final AttributeModifier.Operation operation;
  
  protected final Map<LootRarity, StepFunction> values;
  
  protected final List<Attribute> attributes;
  
  static {
    CODEC = RecordCodecBuilder.create(inst -> inst.group(gemClass(), (App)PlaceboCodecs.enumCodec(AttributeModifier.Operation.class).fieldOf("operation").forGetter(()), (App)VALUES_CODEC.fieldOf("values").forGetter(()), (App)BuiltInRegistries.f_256951_.m_194605_().listOf().fieldOf("attributes").forGetter(())).apply((Applicative)inst, dev.shadowsoffire.apotheosis.adventure.socket.gem.bonus.special.AllStatsBonus::new));
  }
  
  public AllStatsBonus(GemClass gemClass, AttributeModifier.Operation op, Map<LootRarity, StepFunction> values, List<Attribute> attributes) {
    super(Apotheosis.loc("all_stats"), gemClass);
    this.operation = op;
    this.values = values;
    this.attributes = attributes;
  }
  
  public void addModifiers(ItemStack gem, LootRarity rarity, BiConsumer<Attribute, AttributeModifier> map) {
    UUID id = GemItem.getUUIDs(gem).get(0);
    for (Attribute attr : this.attributes) {
      AttributeModifier modif = new AttributeModifier(id, "apoth.gem_modifier.all_stats_buff", ((StepFunction)this.values.get(rarity)).min(), this.operation);
      map.accept(attr, modif);
    } 
  }
  
  public Component getSocketBonusTooltip(ItemStack gem, LootRarity rarity) {
    StepFunction value = this.values.get(rarity);
    return (Component)Component.m_237110_("bonus." + getId() + ".desc", new Object[] { Affix.fmt(value.get(0.0F) * 100.0F) }).m_130940_(ChatFormatting.YELLOW);
  }
  
  public dev.shadowsoffire.apotheosis.adventure.socket.gem.bonus.special.AllStatsBonus validate() {
    Preconditions.checkNotNull(this.operation, "Invalid AllStatsBonus with null operation");
    Preconditions.checkNotNull(this.values, "Invalid AllStatsBonus with null values");
    return this;
  }
  
  public boolean supports(LootRarity rarity) {
    return this.values.containsKey(rarity);
  }
  
  public int getNumberOfUUIDs() {
    return 1;
  }
  
  public Codec<? extends GemBonus> getCodec() {
    return (Codec)CODEC;
  }
}
